include "atari5200.inc"
include "Vram.inc"
include "ZeroPage.inc"

ext InitVram_
ext InitSound_, SoundHandler
ext DisplayList0, DisplayList1
ext UpdateSprites, DisplayListHandler, InitSprites

dseg
NmiJump1:
    defs 3
NmiJump2:
    defs 3
TimerCount: 
    defb 0
CHBAS: public CHBAS
    defb 0

cseg
Colors:
    defb $38 ; 708 01
    defb $ac ; 709 10
    defb $fc ; 710 11
    defb $0f ; 711 11 or $80
    defb $00 ; 712 00
cseg
Init_: public Init_
    pha
        jsr InitSprites
        jsr InitVram_

        lda #4 | sta CONSOL
        lda #low DisplayList0 | sta SDLSTL
        lda #high DisplayList0 | sta SDLSTH

        lda #$39 | sta SDMCTL | sta DMACTL
        lda #3 | sta GRACTL
        lda #$11 | sta PRIOR

        ldx #0
        do
            lda Colors,x
            sta COLOR0,x
            inx
            cpx #5
        while ne | wend

        jsr InitSound_
        lda #0 | sta TimerCount

        lda #$4c | sta NmiJump1 | sta NmiJump2  ; jmp
        lda VVBLKI  | sta NmiJump1+1
        lda VVBLKI+1 | sta NmiJump1+2
        lda #low VBlankHandler1 | sta VVBLKI
        lda #high VBlankHandler1 | sta VVBLKI+1
        lda VVBLKD  | sta NmiJump2+1
        lda VVBLKD+1 | sta NmiJump2+2
        lda #low VBlankHandler2 | sta VVBLKD
        lda #high VBlankHandler2 | sta VVBLKD+1

        sei
            lda #low DisplayListHandler | sta VDSLST
            lda #high DisplayListHandler | sta VDSLST+1
            lda #$c0 | sta NMIEN
        cli
    pla
rts


VBlankHandler1: public VBlankHandler1
    pha
        lda CHBAS | sta CHBASE
    pla
jmp NmiJump1

VBlankHandler2: public VBlankHandler2
    pha
    txa | pha
    tya | pha
        inc TimerCount
        jsr SoundHandler
        jsr UpdateSprites
    pla | tay
    pla | tax
    pla
jmp NmiJump2
; jmp XITVBV


; void WaitTimer(byte t);
dseg
WaitTimer_@Param0: public WaitTimer_@Param0
    defb 0
cseg
WaitTimer_: public WaitTimer_
    pha
        do
            lda TimerCount
            cmp WaitTimer_@Param0
        while cc | wend
        sei
            lda #0 | sta TimerCount
        cli
    pla
rts