constexpr ptr<byte> Vram0 = (ptr<byte>)0x800;
constexpr ptr<byte> Vram1 = (ptr<byte>)0xc00;
constexpr ptr<byte> CharRam0 = (ptr<byte>)0x1000;
constexpr ptr<byte> CharRam1 = (ptr<byte>)0x1400;
constexpr ptr<byte> PlayerRam0 = (ptr<byte>)0x1800;
constexpr ptr<byte> PlayerRam1 = (ptr<byte>)0x2000;

constexpr ptr<byte> Vram = Vram0;
constexpr byte VramWidth = 32;
constexpr byte VramHeight = 24;
constexpr byte CharHeight = 8;
constexpr byte PatternSize = CharHeight;
constexpr byte VramRowSize = VramWidth;
constexpr byte VramStep = 1;

constexpr byte WindowWidth = VramWidth - 6;
constexpr byte WindowHeight = VramHeight;

extern bool BackgroundChanged;

// extern void VVramToVram();
extern void ClearScreen();
extern word VramOffset(byte x, byte y);
extern ptr<byte> Put(ptr<byte> pVram, byte c);
extern ptr<byte> PrintC(ptr<byte> pVram, byte c);

extern void SetPatternMono(ptr<byte> pSource, byte pattern, byte color, byte count);

extern void ClearBackgound();
// extern void InitBackground();
// extern void BackgroundToVram();
extern void SwitchVram();
extern void UpdateEnemyChars();
extern void SwitchChars();
extern ptr<byte> ForegoundAddress();
extern ptr<byte> BackgoundAddress();
extern void EnemyRowsToVram(ptr<byte> pVram, ptr<byte> pSource, byte width);

extern void InitVram();
extern ptr<byte> Put2C(ptr<byte> pVram, byte c);
extern ptr<byte> Erase2(ptr<byte> pVram);
extern void DrawAll();
