include "Zeropage.inc"
include "atari5200.inc"
include "Vram.inc"
include "Chars.inc"

ext MonoPattern, SpritePattern
ext CHBAS

StarCharRam equ CharRam0+CharHeight*(Char_Star and $7f)

pDestination equ ZW0
pSource equ ZW1

sourceOffset equ ZB0
destinationOffset equ ZB1
sourceByte equ ZB2
xCount equ ZB3
yCount equ ZB4

dseg
ActivePage: public ActivePage
    defb 0
charCount:
    defb 0
charColor:
    defb 0


; void InitVram();
cseg
ColorSource:
    defb 27,3
    defb 16,2
    defb 4,3
    defb 0
InitVram_: public InitVram_
    pha
        lda #high CharRam0 | sta CHBAS
        lda #high Vram0 | sta ActivePage

        lda #low MonoPattern | sta <pSource
        lda #high MonoPattern | sta <pSource+1

        lda #0 | sta <pDestination
        lda #high CharRam0 | sta <pDestination+1

        ldx #0
        do
            lda ColorSource,x
        while ne
            sta charCount | inx
            lda ColorSource,x
            sta charColor | inx
            txa | pha
                do
                    ldy #0 | sty <sourceOffset | sty <destinationOffset
                    do
                        lda (<pSource),y | sta <sourceByte
                        ldy <destinationOffset
                        lda #2 | sta <xCount
                        do
                            lda #0
                            sta (<pDestination),y
                            
                            ldx #4
                            do
                                lda (<pDestination),y
                                asl a
                                asl a
                                sta (<pDestination),y

                                asl <sourceByte
                                if cs
                                    lda charColor
                                else
                                    lda #0
                                endif
                                ora (<pDestination),y
                                sta (<pDestination),y

                                dex
                            while ne | wend       
                            iny
                            dec <xCount
                        while ne | wend
                        sty <destinationOffset

                        ldy <sourceOffset
                        iny
                        sty <sourceOffset
                        cpy #4
                    while ne | wend
                    lda <pSource | clc|adc #4 | sta <pSource
                    lda <pSource+1 | adc #0 | sta <pSource+1

                    lda <pDestination | clc|adc #8 | sta <pDestination
                    lda <pDestination+1 | adc #0 | sta <pDestination+1                

                    dec charCount
                while ne | wend
            pla | tax        
        wend

        ldx #0 
        stx <xCount
        do
            lda #0
            ldy <xCount
            do
            while ne
                sta StarCharRam,x | inx
                sta StarCharRam,x | inx
                dey
            wend
            lda #$30
            sta StarCharRam,x | inx
            sta StarCharRam,x | inx

            lda #0
            ldy <xCount
            do
                cpy #3
            while ne
                sta StarCharRam,x | inx
                sta StarCharRam,x | inx
                iny
            wend
            
            inc <xCount
            lda <xCount
            cmp #4
        while ne | wend

        lda #low CharRam0 | sta <pSource
        lda #high CharRam0 | sta <pSource+1

        lda #low CharRam1 | sta <pDestination
        lda #high CharRam1 | sta <pDestination+1

        ldx #CharHeight/2
        do
            ldy #0
            do
                lda (<pSource),y
                sta (<pDestination),y
                iny
            while ne | wend
            inc <pSource+1
            inc <pDestination+1
            dex
        while ne | wend
    pla
rts


; void ClearScreen();
cseg
Clear1:
    ldx #VramHeight
    do
        lda #Char_Space
        ldy #0
        do
            sta (<pDestination),y
            iny
            cpy #VramWidth
        while ne | wend

        lda <pDestination | clc | adc #low VramWidth | sta <pDestination
        lda <pDestination+1 | adc #high VramWidth | sta <pDestination+1
        dex
    while ne | wend
rts
ClearScreen_: public ClearScreen_
    pha
        lda #low Vram0 | sta <pDestination
        lda #high Vram0 | sta <pDestination+1
        jsr Clear1
        lda #low Vram1 | sta <pDestination
        lda #high Vram1 | sta <pDestination+1
        jsr Clear1
    pla
rts


; ptr<byte> VramOffset(byte x, byte y);
dseg
VramOffset_@Param0: public	VramOffset_@Param0
VramOffset_.x_:	defs 1
VramOffset_@Param1: public	VramOffset_@Param1
VramOffset_.y_:	defs 1
cseg
VramOffset_: public	VramOffset_
	pha
        lda	VramOffset_.y_
        asl a | asl a | asl a  ;*8
        sta <pDestination | lda #0 | sta <pDestination+1
        asl <pDestination | rol <pDestination+1 ;16
        asl <pDestination | rol <pDestination+1 ;32
        lda VramOffset_.x_ | clc | adc <pDestination | tay
        lda <pDestination+1 | adc #0 | tax
	pla
rts



Put1:
    tax
    ldy #0
    sta (<pDestination),y
    lda <pDestination+1
    pha
        clc|adc #high Vram1-high Vram0 | sta <pDestination+1
        txa
        sta (<pDestination),y
    pla
    sta <pDestination+1
rts

; ptr<byte> Put(ptr<byte> pVram, byte c);
dseg
Put_@Param0: public Put_@Param0
Put_.pVram_:	defs 2
Put_@Param1: public Put_@Param1
Put_.c_:	defs 1
cseg
Put_: public Put_
    pha
        lda Put_@Param0 | sta <pDestination
        lda Put_@Param0+1 | sta <pDestination+1
        lda Put_.c_
        jsr Put1
        lda <pDestination | clc|adc #1 | tay
        lda <pDestination+1 | adc #0 | tax
    pla
rts


; ptr<byte> PrintC(ptr<byte> pVram, byte c);
dseg
PrintC_@Param0: public PrintC_@Param0
PrintC_.pVram_:	defs 2
PrintC_@Param1: public PrintC_@Param1
PrintC_.c_:	defs 1
cseg
CharTable:
    defb '0123456789ABCEFGHIMNOPRSTUV'
PrintC_: public PrintC_
    pha
        lda PrintC_.c_
        ldx #0
        do
            cmp CharTable,x
            beq PrintC_exit
            inx
            cpx #27
        while ne | wend
        ldx #Char_Space
        PrintC_exit:        
        lda PrintC_@Param0 | sta <pDestination
        lda PrintC_@Param0+1 | sta <pDestination+1
        txa
        ora #$80
        jsr Put1
        lda <pDestination | clc|adc #1 | tay
        lda <pDestination+1 | adc #0 | tax
    pla
rts

