include "Zeropage.inc"
include "atari5200.inc"
include "Vram.inc"
include "Chars.inc"

ext EnemyPattern
ext EnemyRowLeft_
ext ActivePage
ext DisplayList0,DisplayList1
ext CHBAS

EnemyCharOffset equ CharHeight*Char_Enemy

pDestination equ ZW0
pSource equ ZW1
wBits equ ZW2

destinationOffset equ ZB0
sourceOffset equ ZB1
count equ ZB2
lShift equ ZB3
rShift equ ZB4


; void ClearBackgound();
cseg
ClearBackgound_: public ClearBackgound_
    pha
        lda #0 | sta <pDestination
        lda ActivePage
        eor #high Vram1 - high Vram0

        sta <pDestination+1

        ldx #VramHeight
        do
            lda #Char_Space
            ldy #0
            do
                sta (<pDestination),y | iny
                cpy #WindowWidth
            while ne | wend
            lda <pDestination | clc|adc #VramWidth | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1
            dex
        while ne | wend
    pla
rts


; void EnemyRowsToVram(ptr<byte> pVram, ptr<byte> pSource, byte width);
dseg
EnemyRowsToVram_@Param0: public EnemyRowsToVram_@Param0
EnemyRowsToVram_pVram:
    defw 0
EnemyRowsToVram_@Param1: public EnemyRowsToVram_@Param1
EnemyRowsToVram_pSource:
    defw 0
EnemyRowsToVram_@Param2: public EnemyRowsToVram_@Param2
EnemyRowsToVram_width:
    defb 0
cseg
EnemyRowsToVram_: public EnemyRowsToVram_
    pha
        lda EnemyRowsToVram_pVram | sta <pDestination
        lda EnemyRowsToVram_pVram+1 | sta <pDestination+1

        lda EnemyRowsToVram_pSource | sta <pSource
        lda EnemyRowsToVram_pSource+1 | sta <pSource+1

        ldx #2
        do
            ldy #0
            do
                lda (<pSource),y | sta (<pDestination),y
                iny
                cpy EnemyRowsToVram_width
            while ne | wend
            lda <pSource | clc|adc #12*2+1 | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1

            lda <pDestination | clc|adc #VramWidth | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1
            
            dex
        while ne | wend
    pla
rts


; void SwitchVram();
cseg
SwitchVram_: public SwitchVram_
    pha
        lda ActivePage
        eor #high Vram1 - high Vram0
        sta ActivePage
        cmp #high Vram0
        if eq
            lda #low DisplayList0 | sta SDLSTL
            lda #high DisplayList0 | sta SDLSTH
        else
            lda #low DisplayList1 | sta SDLSTL
            lda #high DisplayList1 | sta SDLSTH
        endif
    pla
rts


; void UpdateEnemyChars();
cseg
UpdateEnemyChars_: public UpdateEnemyChars_
    pha
        lda #low EnemyCharOffset | sta <pDestination
        lda CHBAS
        eor #high CharRam1 - high CharRam0
        clc|adc #high EnemyCharOffset
        sta <pDestination+1

        lda #low EnemyPattern | sta <pSource
        lda #high EnemyPattern | sta <pSource+1

        lda EnemyRowLeft_ | and #3 | asl a | sta <rShift
        lda #8 | sec|sbc <rShift | sta <lShift

        lda #3 | sta <count
        do
            ldy #0 | sty <destinationOffset
            do
                lda (<pSource),y | iny
                iny
                sty <sourceOffset
                
                ldx <rShift
                do
                while ne
                    lsr a
                    dex
                wend
                ldy <destinationOffset
                sta (pDestination),y
                iny | sty <destinationOffset

                ldy <sourceOffset
                cpy #CharHeight*2*2
            while ne | wend
                                                _deb: public _deb

            ldy #0
            do
                iny
                lda (<pSource),y | iny
                sty <sourceOffset
                
                ldx <lShift
                do
                while ne
                    asl a
                    dex
                wend
                ldy <destinationOffset
                sta (pDestination),y
                iny | sty <destinationOffset

                ldy <sourceOffset
                cpy #CharHeight*2*2
            while ne | wend

            ldy #0
            do
                lda (<pSource),y | sta <wBits | iny
                lda (<pSource),y | sta <wBits+1 | iny
                sty <sourceOffset

                ldx <rShift
                do
                while ne
                    lsr <wBits+1 | ror <wBits
                    dex
                wend
                lda <wBits
                ldy <destinationOffset
                sta (pDestination),y
                iny | sty <destinationOffset

                ldy <sourceOffset
                cpy #CharHeight*2*2
            while ne | wend

            ldy #0
            do
                lda (<pSource),y | sta <wBits | iny
                lda (<pSource),y | sta <wBits+1 | iny
                sty <sourceOffset

                ldx <lShift
                do
                while ne
                    asl <wBits+1 | rol <wBits
                    dex
                wend
                lda <wBits
                ldy <destinationOffset
                sta (pDestination),y
                iny | sty <destinationOffset

                ldy <sourceOffset
                cpy #CharHeight*2*2
            while ne | wend

            lda <pSource | clc|adc #CharHeight*4 | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1

            lda <pDestination | clc|adc #CharHeight*2*4 | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1

            dec <count
        while ne | wend
    pla
rts


; void SwitchChars();
cseg
SwitchChars_: public SwitchChars_
    pha
        lda CHBAS
        eor #high CharRam1 - high CharRam0
        sta CHBAS
    pla
rts


; ptr<byte> ForegoundAddress();
cseg
ForegoundAddress_: public ForegoundAddress_
    ldx ActivePage
    ldy #0
rts


; word BackgoundAddress();
cseg
BackgoundAddress_: public BackgoundAddress_
    pha
        lda ActivePage
        eor #high Vram1 - high Vram0
        tax
        ldy #0
    pla
rts
